#/usr/bin/perl -w

my @sysdirs = ("/",
	       "/usr",
	       "/usr/bin",
	       "/usr/sbin",
	       "/usr/include",
	       "/usr/lib",
	       "/usr/lib/X11",
	       "/usr/lib/X11/app-defaults",
	       "/usr/share",
	       "/usr/share/man",
	       "/usr/share/man/man1",
	       "/usr/share/man/man3");

$receipts_dir = "/Library/Receipts";

my @pkgs;
my @packages = `ls $receipts_dir`;
for (@packages){
    push(@pkgs,$1) if /(SGIvizdev-\S+).pkg/;
}

for (@pkgs){
    my $pkg = $_;
    my $bom = "$receipts_dir/$pkg.pkg/Contents/Archive.bom";
    next unless -e $bom;
    print "REMOVING PACKAGE $pkg.pkg\n";
    remove_files($bom);
    remove_dirs($bom);
    remove_receipts($pkg);
}

#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#
sub remove_files(){
    my $bom = shift;
    open LSBOM, "/usr/bin/lsbom -l -f -p f '$bom' |" or return;
    while (<LSBOM>){
	chomp;
	s/^\.//;
	my $file = $_;
	next if (!defined ($file) || $file eq "");
	next unless -e $file;
	print "f $file\n";
        if ((unlink $file) != 1){
            print "ERROR: unable to remove $file\n";
	}
    }
    close LSBOM;    
}

#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#
sub remove_dirs(){
    my $bom = shift;
    my @dirs;
    open LSBOM, "/usr/bin/lsbom -d -p f '$bom' |" or return;
    while (<LSBOM>){
	chomp;
	s/^\.//;
	my $dir = $_;
	next if (!defined ($dir) || $dir eq "");
	next unless -d $dir;
	next if grep(/^$dir$/,@sysdirs);
	push(@dirs,$dir);
    }
    close LSBOM;
    @dirs = sort {$b cmp $a} @dirs;
    for (@dirs){
	my $ls = `ls $_`;
	next if $ls;
	print "d $_\n";
	rmdir $_;
    }
}

#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#
sub remove_receipts{
    my $pkg = shift;
    $pkg =~ s/\///g;
    return if (!defined ($pkg) || $pkg eq "" || $pkg eq "." || $pkg eq "..");

    my $pkgdir = "$receipts_dir/$pkg.pkg";
    return if (!defined ($pkgdir) || $pkgdir eq "" || ! -d $pkgdir);

    my @rm = ('/bin/rm', '-rf', "$pkgdir");
    print "@rm\n";
    system @rm;
    my $retcode = $? >> 8;
    if ($retcode != 0){
	print "Warning:  There may have been a problem removing \"$pkgdir\"\n";
    }
}

#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#=#
